<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Registro</title>
  </head>
  <body>
    <div id="registro" style="display: none">
      <h1>Registro de Usuarios</h1>
      <form name="registro" action="" method="get">
        <label for="email">Email</label>
        <input type="email" name="email" id="email" required />
        <br /><br />
        <label for="nombre">Nombre</label>
        <input type="text" name="nombre" id="nombre" required />
        <br /><br />
        <label for="apellido">Apellido</label>
        <input type="text" name="apellido" id="apellido" required />
        <br /><br />
        <label for="pais">País</label>
        <select name="pais" id="pais">
          <option value="argentina">Argentina</option>
          <option value="brasil">Brasil</option>
          <option value="chile">Chile</option>
          <option value="colombia">Colombia</option>
          <option value="peru">Perú</option>
          <option value="venezuela">Venezuela</option>
        </select>
        <br /><br />
        <label for="contrasena">Contraseña</label>
        <input type="password" name="contrasena" id="contrasena" required />
        <br /><br />
        <label for="rcontrasena">Repetir Contraseña</label>
        <input type="password" name="rcontrasena" id="rcontrasena" required />
        <br /><br />
        <input type="button" name="btnRegistro" id="btnRegistro" value=" Registrar" />
      </form>
      <br /><br />
    </div>

    <div id="login">
      <form name="login" action="" method="get">
        <label for="emailLogin">Email</label>
        <input type="email" name="emailLogin" id="emailLogin" required />
        <br /><br />
        <label for="contraseniaLogin">Contraseña</label>
        <input type="password" name="contraseniaLogin" id="contraseniaLogin" required />
        <br /><br />
        <input type="button" name="botonLogin" id="botonLogin" value=" Login" />
        <input
          type="button"
          name="nuevoRegistro"
          id="nuevoRegistro"
          value="Nuevo Registro"
        />
      </form>
    </div>
    <div id="mensaje"></div>
    <script type="text/javascript">
      const btnRegistro = document.getElementById("btnRegistro");
      const btnNuevoRegistro = document.getElementById("nuevoRegistro");
      const txtEmail = document.getElementById("email");
      const btnLogin = document.getElementById("botonLogin"); 

      class Usuario {
        constructor(nombre, apellido, email, pais, contrasena, rcontrasena) {
          this.nombre = nombre;
          this.apellido = apellido;
          this.email = email;
          this.pais = pais;
          this.contrasena = contrasena;
          this.rcontrasena = rcontrasena;
        }
        get nombreCompleto() {
          return this.apellido, ", ", this.nombre;
        }
      }

      //Declaro todas las variables que necesito
      listaUsuarios = [];
      let usuario = new Usuario();
      txtEmail.addEventListener("focusout", function () {
        usuario.email = document.getElementById("email").value;
        console.log(listaUsuarios);
        if (email === "") {
          console.log("Debe ingresar un valor para el mail");
          txtEmail.focus();
        } else {
          listaUsuarios.forEach((element) => {
            let verifico = element["email"] === usuario.email ? true : false;
          if (verifico) {
            console.log("El mail existe por favor ingrese otro");
            document.getElementById("mensaje").innerHTML = "El mail existe por favor ingrese otro";
            txtEmail.focus();
            return;
          }
          });
        }
      });

      btnRegistro.addEventListener("click", function () {
        console.log("ingresa login");
        usuario.nombre = document.getElementById("nombre").value;
        usuario.apellido = document.getElementById("apellido").value;
        usuario.email = document.getElementById("email").value;
        usuario.pais = document.getElementById("pais").value;
        usuario.contrasena = document.getElementById("contrasena").value;
        usuario.rcontrasena = document.getElementById("rcontrasena").value;
        if (usuario.nombre != "" && usuario.apellido != "" && usuario.email != "" &&
            usuario.contrasena != "" && usuario.rcontrasena != "") {
            console.log(`${usuario.contrasena} = ${usuario.rcontrasena}`);
            if (usuario.contrasena === usuario.rcontrasena) {
              listaUsuarios.push(usuario);
              document.getElementById("mensaje").innerHTML = `Nombre: ${usuario.nombre} \n  Apellido: ${usuario.apellido} \n  Email: ${usuario.email} \n País: ${usuario.pais} \n contraseña: ${usuario.contrasena} \n rcontraseña: ${usuario.rcontrasena} \n `;
              //limpio variable usario
              usuario = new Usuario();
              limpiarFormulario();
            } else {
              document.getElementById("mensaje").innerHTML = "Las contraseñas no son iguales";
            } //if compara si son iguales los campos de contraseña
          } else {
              document.getElementById("mensaje").innerHTML = "Faltan campos completar";
          } //if de campos vacios
      }); //funcion btn click

      btnNuevoRegistro.addEventListener("click", function () {
          muestra_oculta("registro");
          muestra_oculta("login");
        });
      function limpiarFormulario() {
        document.getElementById("nombre").value  = "";
        document.getElementById("apellido").value  = "";
        document.getElementById("email").value  = "";
        document.getElementById("pais").value  = "";
        document.getElementById("contrasena").value  = "";
        document.getElementById("rcontrasena").value = "";
        muestra_oculta("registro");
        muestra_oculta("login");
      }

      function muestra_oculta(id){
        if (document.getElementById){ //se obtiene el id
          var el = document.getElementById(id); //se define la variable "el" igual a nuestro div
          el.style.display = (el.style.display == 'none') ? 'block' : 'none'; //damos un atributo display:none que oculta el div
        }
      }

      btnLogin.addEventListener('click', function () {
        let contrasenia = document.getElementById("contraseniaLogin").value;
        let email = document.getElementById("emailLogin").value;
        let verifico = false;
        listaUsuarios.forEach((element) => {
          verifico =  element["email"] === email & 
                      element["contrasena"] === contrasenia
                      ? true : false;
          });        
        if (verifico) {
              document.getElementById('mensaje').innerHTML = "Contraseña Correcta!!!";
          }else{
              document.getElementById('mensaje').innerHTML = "Usuario o Contraseña Incorrecta";
          }
      });//funcion btn click
    </script>
  </body>
</html>
